=== debian/changelog ===
yabause (0.9.12-2) unstable; urgency=low

  * Upload to unstable.
  * Standards-Version: 3.9.4

 -- Evgeni Golov <evgeni@debian.org>  Thu, 16 May 2013 07:13:36 +0200

yabause (0.9.12-1) experimental; urgency=low

  * New upstream release.
  * Drop use_dpkg_buildflags.patch and disable_dynarec_on_arm.patch
    Applied and/or deprecated upstream.
  * Set YAB_OPTIMIZATION="" to force using Debian's -O2 and not upstreams -O3.
  * Build-Depend on debhelper (>= 9)

 -- Evgeni Golov <evgeni@debian.org>  Fri, 25 Jan 2013 20:59:56 +0100
